/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sante)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------
*/

#include "vtkVectorsVisu.h"

#include "vtkProperty.h"

//Borrame
#include "vtkPointData.h"


//------------------------------------------------------------------------------
vtkVectorsVisu::vtkVectorsVisu()
  :vtkVectorsTensorsVisuBase()
{
	_vtkarrowsource	= vtkArrowSource::New();
	_vtklinesource		= vtkLineSource::New();
	_vtkglyph			= vtkGlyph3D::New();
}


//------------------------------------------------------------------------------
vtkVectorsVisu::~vtkVectorsVisu()
{
}

//------------------------------------------------------------------------------
void vtkVectorsVisu::Process()
{
printf("EED vtkVectorsVisu::Process()  start\n");
     if(_active==true)
     {
         _vtkglyph->SetInput( GetDataObject() );  

			if(GetTypeForm()==1)								// source Arrow
			{
	         _vtkglyph->SetSource( _vtkarrowsource->GetOutput() );
			} else {												// source Line
				_vtkglyph->SetSource( _vtklinesource->GetOutput() );   	
			}


         _vtkglyph->SetScaleModeToScaleByVector();
         _vtkglyph->SetColorModeToColorByVector();
         _vtkglyph->SetScaleFactor( GetScaleFactor() );
         _vtkglyph->Update();

         _pdm->SetInput( _vtkglyph->GetOutput());

vtkPointData 	*data	= _vtkglyph->GetOutput()->GetPointData();
printf("EED -------------------------------------------\n");
_vtkglyph->GetOutput()->Print(std::cout);
printf("EED -------------------------------------------\n");
data->Print(std::cout);
printf("EED -------------------------------------------\n");			
int i,sizeDa = data->GetNumberOfArrays();
printf("EED vtkVectorsVisu::Process  sizeDa %d \n", sizeDa );
for (i=0;i<sizeDa;i++)
{
	printf("EED vtkVectorsVisu::Process-name %d, %s \n", i, data->GetArrayName(i) );
	data->GetArray(i)->Print(std::cout);
	printf("EED -------------------------------------------\n");
}

//EED         _pdm->SetScalarRange( range );
//EED         vtkPolyData	*pd			= vGlyphFlowPlane->GetOutput();
//EED         vtkPointData	*pointdata		= pd->GetPointData();
//EED         vtkDataArray	*da			= pointdata->GetVectors();
//EED         vtkDataArray *nda = vtkFloatArray::New();
//EED         nda->DeepCopy(da);
//       pointdata->RemoveArray( "GlyphVector" );
//       bbGetInputIn()->GetPointData()->RemoveArray( "GlyphVector" );
//EED         pointdata->AddArray( nda );
//EED         bbGetInputIn()->GetPointData()->AddArray( nda );
//EED2         _pdm->ScalarVisibilityOn();
         _pdm->SetScalarModeToUsePointFieldData();
         _pdm->SetLookupTable( _LutEED );
         _pdm->SelectColorArray( "GlyphVector" );

//       vSliceMapperVec->SetLookupTable( vGreenToRedLut );
//       vSliceMapperVec->SetColorModeToMapScalars();

         _actor->SetMapper( _pdm );
         _actor->GetProperty()->SetOpacity( GetOpacity() );
    }// if _active

    VisibilityActor(); 
printf("EED vtkVectorsVisu::Process()  end\n");
}
	





